﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using WpfApplication1.Model;

namespace WpfApplication1.ViewModel
{
    public class MainWindowViewModel : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Implementation
        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion

        private ObservableCollection<TreeItem> _items = new ObservableCollection<TreeItem>();
        public ObservableCollection<TreeItem> Items
        {
            get { return _items; }
            set
            {
                if (_items != value)
                {
                    _items = value;
                    OnPropertyChanged("Items");
                }
            }
        }

        public MainWindowViewModel()
        {
            Items.Add(new TreeItem { Label = "Root 1", IsExpanded = false, IsSelected = false });
            Items.Add(new TreeItem { Label = "Root 2", IsExpanded = false, IsSelected = false });
            Items.Add(new TreeItem { Label = "Root 3", IsExpanded = false, IsSelected = false });

            Items[0].Children.Add(new TreeItem { Label = "Root 1 Child 1", IsExpanded = false, IsSelected = false });
            Items[0].Children.Add(new TreeItem { Label = "Root 1 Child 2", IsExpanded = false, IsSelected = false });
            Items[0].Children.Add(new TreeItem { Label = "Root 1 Child 3", IsExpanded = false, IsSelected = false });
        }
    }
}
